// another fine solution by misof
#include <vector>
#include <list>
#include <cstdio>
using namespace std;

#include <list>
#define MAX 234567

int N, M, K;
int color[MAX];
list<int> members[MAX];
int E[MAX][2];
int D[MAX];
int damaged[MAX];
int components;
int answer[MAX];

void join(int x, int y) {
  if (color[x]==color[y]) return;
  --components;
  list<int> &A = members[ color[x] ];
  list<int> &B = members[ color[y] ];
  for (list<int>::iterator it = B.begin(); it != B.end(); ++it) {
    color[ *it ] = color[ *A.begin() ];
    A.insert( A.end(), *it );
  }
  B.clear();
}

int main() {
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
  scanf("%d%d",&N,&M);
  components = N;
  for (int n=1; n<=N; ++n) members[n].push_back(n);
  for (int n=1; n<=N; ++n) color[n] = n;
  for (int m=1; m<=M; ++m) scanf("%d%d",&E[m][0],&E[m][1]);
  scanf("%d",&K);
  for (int k=1; k<=K; ++k) { scanf("%d",&D[k]); damaged[D[k]]=1; }
  for (int m=1; m<=M; ++m) if (!damaged[m]) join(E[m][0],E[m][1]);
  answer[0] = components-1;
  for (int k=K; k>=1; --k) { join(E[D[k]][0],E[D[k]][1]); answer[K+1-k]=components-1; }
  for (int k=K; k>=0; --k) printf("%d\n",answer[k]);
}
