// another fine solution by misof
#include <vector>
#include <queue>
#include <cstdio>
using namespace std;

#define MAX 1234567

int N, M, K;
int E[MAX][3];
vector< vector<int> > G;

int main() {
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
  scanf("%d%d",&N,&M);
  G.resize(N+1);
  for (int m=1; m<=M; ++m) { 
    scanf("%d%d",&E[m][0],&E[m][1]); 
    E[m][2]=M+1; 
    G[ E[m][0] ].push_back(m); 
    G[ E[m][1] ].push_back(m); 
  }
  scanf("%d",&K);
  for (int k=1; k<=K; ++k) {
    int d;
    scanf("%d",&d); 
    E[d][2]=k; 
  }
  for (int k=0; k<=K; ++k) {
    int components = 0;
    int uz[N+1];
    for (int a=1; a<=N; ++a) uz[a]=0;
    for (int a=1; a<=N; ++a) if (!uz[a]) {
      ++components;
      queue<int> Q;
      Q.push(a);
      uz[a] = 1;
      while (!Q.empty()) {
        int kde = Q.front(); Q.pop();
        for (int i=0; i<int(G[kde].size()); ++i) {
          int e = G[kde][i];
          if (E[e][2] <= k) continue;
          int kam = E[e][0] + E[e][1] - kde;
          if (uz[kam]) continue;
          uz[kam] = 1;
          Q.push(kam);
        }
      }
    }
    printf("%d\n",components-1);
  }
}
