// another fine solution by misof
#include <vector>
#include <cstdio>
using namespace std;

#define MAX 234567

int N, M, K;
int color[MAX], cnt[MAX], first[MAX], next[MAX];
int E[MAX][2];
int D[MAX];
int damaged[MAX];
int components;
int answer[MAX];

void join(int x, int y) {
  x=color[x]; y=color[y];
  if (x==y) return;
  --components;
  int a = first[x], b = next[a];
  while (a) {
    next[a] = first[y];
    color[a] = y;
    first[y] = a;
    a = b;
    b = next[a];
  }
}

int main() {
  freopen("hurikan.in", "r", stdin);
  freopen("hurikan.out", "w", stdout);
  scanf("%d%d",&N,&M);
  components = N;
  for (int n=1; n<=N; ++n) color[n] = n, cnt[n] = 1, first[n]=n, next[n] = 0;
  for (int m=1; m<=M; ++m) scanf("%d%d",&E[m][0],&E[m][1]);
  scanf("%d",&K);
  for (int k=1; k<=K; ++k) { scanf("%d",&D[k]); damaged[D[k]]=1; }
  for (int m=1; m<=M; ++m) if (!damaged[m]) join(E[m][0],E[m][1]);
  answer[0] = components-1;
  for (int k=K; k>=1; --k) { join(E[D[k]][0],E[D[k]][1]); answer[K+1-k]=components-1; }
  for (int k=K; k>=0; --k) printf("%d\n",answer[k]);
}
